#!/usr/bin/perl 

print ("Content-type: text/html\n\n");

eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "gb_variables.pl";
require "ugb_lib.pl";
require "gb_styles.pl";
};

&ReadParse;

#adjust bgcolor variables
if ($BGColor ne ""){
$BGColor = qq(bgcolor="$BGColor");
}
if ($TableColorStrip ne "") {
$TableColorStrip = qq(bgcolor="$TableColorStrip");
}
if ($AltRowColor1 ne "") {
$AltRowColor1 = qq(bgcolor="$AltRowColor1");
}
if ($AltRowColor2 ne "") {
$AltRowColor2 = qq(bgcolor="$AltRowColor2");
}
if ($PageBackground ne "") {
$PageBackground = qq(background="$PageBackground");
}

if ($TableBorderColor ne ""){
$TableWidth2 = "100%";
$BorderTop = qq(<table border=0 cellpadding=0 cellspacing=0 width="$TableWidth"><TR><td bgcolor="$TableBorderColor">);
$BorderBottom = qq(</td></tr></table> );
}  else {
$TableWidth2 = $TableWidth;
$BorderTop = "";
$BorderBottom = "";
}
if (@in == 0) {
&Summary;
}
if ($in{'action'} eq "summary") {
&Summary;
}
if ($in{'action'} eq "addentry") {
&AddEntry;
}
if ($in{'action'} eq "submitentry") {
&SubmitEntry;
}

sub SubmitEntry {
if ($in{'Field1Value'} eq "") {
       &StandardHTML("zg \"$Field1 \" .");
exit;
}
if ($in{'Field4Value'} eq "") {
       &StandardHTML("zg \"$Field4\" .");
exit;
}
&GetDateTime;  #get current date and time

#add entry to entries.file
if ($TimeFormat eq "US") {
	$ThisTime = $USTime;
} else {
	$ThisTime = $EuroTime;
}

if ($DateFormat eq "US") {
	$ThisDate = "$USDate";
}
elsif ($DateFormat eq "USExpanded") {
	$ThisDate = "$USDateExpanded";
}
elsif ($DateFormat eq "Euro") {
	$ThisDate = "$EuroDate";
}  else {
	$ThisDate = "$EuroDateExpanded";
}
$Field1Value = &decodeURL($in{'Field1Value'});
$Field1Value = &CleanThis($Field1Value);
$Field1Value = &PipeCleaner($Field1Value);
$Field2Value = &decodeURL($in{'Field2Value'});
$Field2Value = &CleanThis($Field2Value);
$Field2Value = &PipeCleaner($Field2Value);
$Field3Value = &decodeURL($in{'Field3Value'});
$Field3Value = &CleanThis($Field3Value);
$Field3Value = &PipeCleaner($Field3Value);
$Field4Value = &decodeURL($in{'Field4Value'});
$Field4Value = &PipeCleaner($Field4Value);

#HTML NOT ALLOWED IN FIRST 3 FIELDS!
	$Field1Value =~ s/<.+?>//g;
	$Field2Value =~ s/<.+?>//g;
	$Field3Value =~ s/<.+?>//g;
	
	if ($Field2Value ne "") {
	if ($Field2Hyper eq "url") {
		if ($Field2Value =~ /http:/) {
			$Field2Value = qq(<A HREF="$Field2Value">$Field2Value</A>);
		}  else {
			$Field2Value = qq(<A HREF="http://$Field2Value">$Field2Value</A>);
		}
	
	}
	elsif ($Field2Hyper eq "email") {
				$Field2Value = qq(<A HREF="mailto:$Field2Value">$Field2Value</A>);
	}  else {
	$Field2Value = $Field2Value;
	}
	}  #end Field2Value ne ""
	
	if ($Field3Value ne "") {
	if ($Field3Hyper eq "url") {
		if ($Field3Value =~ /http:/) {
			$Field3Value = qq(<A HREF="$Field3Value">$Field3Value</A>);
		}  else {
			$Field3Value = qq(<A HREF="http://$Field3Value">$Field3Value</A>);
		}
	
	}
	elsif ($Field3Hyper eq "email") {
				$Field2Value = qq(<A HREF="mailto:$Field3Value">$Field3Value</A>);
	}  else {
	$Field3Value = $Field3Value;
	}
	} #end Field3Value ne ""
	
if ($HTMLAllow ne "yes") {
	$Field4Value =~ s/<.+?>//g;
}
$Field4Value = &Truncate($Field4Value);
$Field4Value = &ConvertReturns($Field4Value);

if ($Censor eq "ON") {
@censored = split(/ /, $censorwords);
 $Field4Value = &CensorCheck("$Field4Value");
}

#Smiley/Frown conversion---
$Field4Value = &Smilies("$Field4Value");

#UBB Code-ify (if allowed)
if ($UBBCodeAllow eq "yes") {
$Field4Value = &UBBCode("$Field4Value");
} #END UBB CODE 

#determine ID NUMBER
if (-e "$GB_NON_CGI_Path/entries.file") {
open (OLDENTRIES, "$GB_NON_CGI_Path/entries.file") || die ("Couldn't open guestbook entries file.");
 @entries = <OLDENTRIES>;
close (OLDENTRIES);
@backwards = reverse(@entries);
$lastline = @backwards[0];
@laststats = split(/\|\|/, $lastline);
$LastNumber = $laststats[6];
chomp($LastNumber);
$NextNumber = $LastNumber + 1;
}  else {
$NextNumber = 1;
}




open (ENTRIES, ">>$GB_NON_CGI_Path/entries.file");
print ENTRIES "$ThisDate||$ThisTime||$Field1Value||$Field2Value||$Field3Value||$Field4Value||$NextNumber\n";
close (ENTRIES);

chmod (0666, "$GB_NON_CGI_Path/entries.file");

&TopHTML;

print<<TEST;
$ConfirmAddWording
<P>
<CENTER>
<A HREF="ugb.cgi">dݯd</A> | <A HREF="$Link1URL">$Link1Name</A> | <A HREF="$Link2URL">$Link2Name</A>
</CENTER>
TEST

&BottomHTML;


}  #end Submit Entry


sub AddEntry {
&TopHTML;

if ($UBBCodeAllow eq "yes") {
        $UBBLine = qq(<IMG SRC="$NonCGIURL/check.jpg" BORDER=0> UBB Code \ϥ);
} else {
        $UBBLine = qq(<IMG SRC="$NonCGIURL/x.jpg" BORDER=0> UBB Code Tϥ);
}

if ($HTMLAllow eq "yes") {
        $HTMLLine = qq(<IMG SRC="$NonCGIURL/check.jpg" BORDER=0> HTML \ϥ);
} else {
        $HTMLLine = qq(<IMG SRC="$NonCGIURL/x.jpg" BORDER=0> HTML Tϥ);
}
print<<MIDDLE;
<P>
$AddEntryIntro
<P>
<center>
$UBBLine &nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $HTMLLine

<FORM ACTION="ugb.cgi" METHOD="POST">
$BorderTop
<table border=0 cellpadding=4 border=0 cellspacing=1 width=$TableWidth2>
<TR $TableColorStrip align=center><TD colspan=2><FONT SIZE="1" FACE="$FontFace" color="$TableStripTextColor"><B>$GBTitle</B></FONT></TD></TR>
<TR $AltRowColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">$Field1 *</FONT></td>
<td><INPUT TYPE="TEXT" NAME="Field1Value" SIZE=$Field1Size MAXLENGTH=$Field1MaxSize></td>
</tr>
MIDDLE

if ($Field2 ne "") {
print<<MID2;
<TR $AltRowColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">$Field2</FONT></td>
<td><INPUT TYPE="TEXT" NAME="Field2Value" SIZE=$Field2Size MAXLENGTH=$Field2MaxSize></td>
</tr>
MID2
}
if ($Field3 ne "") {
print<<MID3;
<TR $AltRowColor2>
<TD><FONT SIZE="$TextSize" FACE="$FontFace">$Field3</FONT></td>
<td><INPUT TYPE="TEXT" NAME="Field3Value" SIZE=$Field3Size MAXLENGTH=$Field3MaxSize></td>
</tr>
MID3
}
print<<ENDTABLE;
<TR $AltRowColor2>
<TD valign=top><FONT SIZE="$TextSize" FACE="$FontFace">$Field4 *</FONT><P><FONT SIZE="1" FACE="$FontFace"><A HREF="$NonCGIURL/ubbcode.html">UBB Code ϥλ</A></FONT></td>
<td><TEXTAREA NAME="Field4Value" WRAP="VIRTUAL" ROWS=5 COLS=25>
</TEXTAREA></td>
</tr>
</table>
$BorderBottom
<P>
* 񶵥
</center>
<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="submitentry">
<CENTER><INPUT TYPE="SUBMIT" VALUE="$AddSubmitWording"></CENTER>
</form>
ENDTABLE

&BottomHTML;
}  # end Add Entry sr


sub Summary {
&TopHTML;

print <<_TOP_OF_PAGE;
<P>
$IntroText
<P>
nñgd, <A HREF="ugb.cgi?action=addentry">o</A>!
<P>
<center>
_TOP_OF_PAGE


&GetEntries;

print <<_BOTTOM_HTML;
</TABLE>
$BorderBottom
</B>
<table border=0 width=$TableWidth>
<tr><td align=left><FONT FACE="$FontFace" size="1"><A HREF="$NonCGIURL/gbcenter.html">dO޲z</A></font></td><td align=right><FONT FACE="$FontFace" size=$TextSize>
$ContinueWording</font></td></tr></table>
<P>
<A HREF="ugb.cgi?action=addentry"><IMG SRC="$NonCGIURL/$AddEntryPic" BORDER=0 ALT="ñgd"></A>
<P>
<A HREF="$Link1URL">$Link1Name</A> | <A HREF="$Link2URL">$Link2Name</A>
<P>
_BOTTOM_HTML

&BottomHTML;

} #end Summary sr



sub UpdateEntries {
if (-e "$GB_NON_CGI_Path/entries.file") {
open (ENTRIES, "$GB_NON_CGI_Path/entries.file") || die ("Couldn't open guestbook entries file.");
 @entries = <ENTRIES>;
close (ENTRIES);
$ArrayLine = 0;
@newarray = @blank;

foreach $one(@entries) {
chomp($one);
$ArrayLine++;
$NewLine = ("$one" . "||$ArrayLine");
push(@newarray, $NewLine);
}

open (THIS, ">$GB_NON_CGI_Path/entries.file") || die ("Couldn't open guestbook entries file.");
foreach $uno(@newarray) {
chomp($uno);
print THIS "$uno\n";
}
close (THIS);

open (DIAG, ">$GB_NON_CGI_Path/diagnostic.file") || die ("Couldn't open guestbook diagnostic file.");
print DIAG "don't delete this file if you are running the Ultimate Guestbook";
close (DIAG);
}
}

sub GetEntries {
unless (-e "$GB_NON_CGI_Path/diagnostic.file") {
&UpdateEntries;
}

if (-e "$GB_NON_CGI_Path/entries.file") {
open (ENTRIES, "$GB_NON_CGI_Path/entries.file") || die ("Couldn't open guestbook entries file.");
 @entries = <ENTRIES>;
close (ENTRIES);

$Total = @entries;
$LastArrayNumber = $Total - 1;
if ($Total < $MaxDisplay) {
	$MaxDisplay = $Total;
}  

@sortentries = reverse(@entries);
$TotalEntries = @sortentries;

#determine start and end points in array
if ($in{'startwith'} eq "") {
$startarraynum = "0";
$start = "1";
}  else {
$startarraynum = $in{'startwith'};
$start = $startarraynum + 1;
}
$MaxDisplay--;

$endarraynum = $startarraynum + $MaxDisplay;
$end = $endarraynum + 1;
if ($end > $Total) {
$endarraynum = $Total - 1;
$end = $Total;
}
$startwith = $endarraynum + 1;


if ($startwith < $Total) {
	$ContinueWording = qq(<A HREF="ugb.cgi?action=summary&startwith=$startwith">Next Entries</A>);
}  else {
	$ContinueWording = "";
}

@finalarray = @sortentries[$startarraynum...$endarraynum];

print<<TableStart;
$BorderTop
<table border=0 cellpadding=4 border=0 cellspacing=1 width=$TableWidth2>
<TR $BGColor><TD align=center colspan=2>
<FONT SIZE="1" FACE="$FontFace"><B>
b <FONT SIZE="1" FACE="$FontFace" color="$LinkColor">$start</FONT> - <FONT SIZE="1" FACE="$FontFace" color="$LinkColor">$end</font>   @<FONT SIZE="1" FACE="$FontFace" color="$LinkColor">$Total</font>g&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; $ContinueWording
</B></FONT>
</td></tr>
<tr $TableColorStrip>
<td>
<B><FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">$Field1</FONT></B></td>
<td>
<B><FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">$Field4</FONT></B></td></tr>
TableStart


$AlternateColor = $AltRowColor1;
for $thisentry(@finalarray)  {
@entryline = split(/\|\|/, $thisentry);
chomp($entryline[6]);

print <<GUTS;
<tr $AlternateColor>
<td width=35% valign=top><FONT SIZE="$TextSize" FACE="$FontFace"><B>$entryline[2]</b></font><BR>
GUTS

if ($entryline[3] ne "") {
print<<THELINE;
<FONT SIZE="1" FACE="$FontFace">
<B>$Field2:</B> $entryline[3]</font><BR>
THELINE
}
if ($entryline[4] ne "") {
print<<THELINE;
<FONT SIZE="1" FACE="$FontFace">
<B>$Field3:</B> $entryline[4]</font><BR>
THELINE
}

print<<Guts2;
</font></td>
<td valign=top><FONT SIZE="1" COLOR="$PostedByColor" FACE="$FontFace">$entryline[0] $entryline[1] $TimeZone o&nbsp;&nbsp;&nbsp;<A HREF="gbadmin.cgi?action=edit&number=$entryline[6]"><IMG SRC="$NonCGIURL/trash.gif"  BORDER=0 ALT="Delete This Entry"></A></font> <HR><FONT SIZE="$TextSize" FACE="$FontFace">$entryline[5]</FONT>
</td></tr>
Guts2

if ($AlternateColor eq "$AltRowColor1") {
$AlternateColor = "$AltRowColor2";
}  else {
$AlternateColor = "$AltRowColor1";
}

}  #end FOREACH

} else {
print<<GUTS;
$BorderTop
<table border=0 cellpadding=4 border=0 cellspacing=1 width=$TableWidth2>
<tr $TableColorStrip>
<td>
<B><FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">$Field1</FONT></B></td>
<td>
<B><FONT SIZE="1" FACE="$FontFace" COLOR="$TableStripTextColor">$Field4</FONT></B></td>
</tr>
<TR $BGColor>
<TD COLSPAN=2>
<FONT SIZE="$TextSize" FACE="$FontFace" COLOR="$VisitedLinkColor"><B>** Sde **</B></FONT>
</td></tr>
GUTS

}

}  #end sr

sub TopHTML {
print<<TOP;
<HTML>
<HEAD>
	<TITLE>$GBTitle</TITLE>
</HEAD>
<BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<FONT FACE="$FontFace" SIZE="$TextSize">
$Header
<BR>
<center>
<A HREF="$CGIURL/ugb.cgi"><IMG SRC="$NonCGIURL/$GBTitlePic" BORDER=0 ALT="$GBTitle"></A>
</center>
TOP

} #end TopHTML sr

sub BottomHTML {
print<<Bottom;
<P>
$Footer
<P>
<center>
<FONT SIZE="1" COLOR="$CopyrightTextColor" FACE="$FontFace">
$CopyrightWording</font>
<P><FONT SIZE="1" FACE="$FontFace">
<A HREF="http://www.madronapark.com/ugb">Ultimate Guestbook</A>, Version 1.0<BR>&copy; <A HREF="http://www.madronapark.com" target=_new>Madrona Park, Inc.</A>, 1999.</FONT>
</CENTER>

</FONT>
</td>
</tr></table>
</BODY>
</HTML>
Bottom
} # end BottomHTML sr


sub GetDateTime  {
if ($TimeZoneOffset) {
if (($TimeZoneOffset ne "") || ($TimeZoneOffset ne "0")) {
$adjustTime = time() + ($TimeZoneOffset * 3600);
}  else {
$adjustTime = time();
}
($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime ($adjustTime);

} else {

($sec, $min, $hour, $mday, $mon, $year, $wday, $yday, $isdst) = localtime (time);

}

$mon++;
$year = $year + 1900;
$monformat = sprintf ("%2d", $mon);
$monformat =~tr/ /0/;
$mdayformat = sprintf ("%2d", $mday);
$mdayformat =~tr/ /0/;

@months = ("blank" , "@", "G", "T", "|", "", "", "C", "K", "E", "Q", "Q@", "QG");

#date format options
$USDate = "$monformat-$mdayformat-$year";
$EuroDate = "$mdayformat-$monformat-$year";
$USDateExpanded = "$months[$mon] $mday, $year";
$EuroDateExpanded = "$mday $months[$mon] $year";

#time format options
$min = sprintf ("%2d", $min);
$min =~tr/ /0/;
$hour = sprintf ("%2d", $hour);
$hour =~tr/ /0/;

$EuroTime = "$hour:$min";
&NormalTime; #convert to US time
$USTime = "$USHour:$min $AMPM";

}  #end GetDateTime sr
		
sub NormalTime {		
if ($hour < 12) {
$AMPM = "AM";
$USHour = "$hour";
}

if ($hour > 12) {
	$USHour = $hour - 12;
	$AMPM = "PM";
	}  	
if ($hour == 12) {
	$AMPM = "PM";
	$USHour = "12";
	}  	
	
if ($hour == 0) {
	$USHour = "12";
	}
	
$UHhour = sprintf ("%2d", $USHour);
$USHour =~tr/ /0/;
}
