### Ultimate Guestbook Library

sub UnHTML {
my $ThisWord = shift;
$ThisWord =~ s/<BR>/\n/ig;
$ThisWord =~ s/<p>/\n\n/ig;
return($ThisWord);
}

sub Lock {
local ($lockname) = @_;
local ($endtime);
$endtime = 15;
$endtime = time + $endtime;
while (-e $lockname && time < $endtime) {
open (LOCKFILE, ">$lockname");
} #end lock sr

sub Unlock {
local ($lockname) = @_;
close (LOCKFILE);
unlink ($lockname);
} 
} # end Unlock sr

sub Truncate {
my $TruncatedWord = shift;
$TruncatedWord =~ s/(\S{50})/$1 /isg;
return ($TruncatedWord);
}

sub CleanThis {
my $CleanThis = shift;
	$CleanThis =~ s/\n\r\n//sg;
	$CleanThis =~ s/\n//sg;
	$CleanThis =~ s/\r//sg;
	$CleanThis =~ s/\t//sg;
	$CleanThis =~ s/\\v//sg;
	$CleanThis =~ s/\f//sg;
		$CleanThis =~ s/\b//sg;
return ($CleanThis);
} #end CleanThis

sub PipeCleaner {
$Pipe = shift;
$Pipe =~ s/\|/ \| /sg;
return($Pipe);
} #end pipe cleaner sr


sub UBBCode {

my $ThePost = shift;

$ThePost =~ s/(\[URL\])(http:\/\/\S+?)(\[\/URL\])/ <A HREF="$2" TARGET=_blank>$2<\/A> /isg;

$ThePost =~ s/(\[URL\])(\S+?)(\[\/URL\])/ <A HREF="http:\/\/$2" TARGET=_blank>$2<\/A> /isg;

$ThePost =~ s/(\[EMAIL\])(\S+\@\S+?)(\[\/EMAIL\])/ <A HREF="mailto:$2">$2<\/A> /isg;


$ThePost =~ s/(\[IMG\])(\S+?)(\[\/IMG\])/ <IMG SRC="$2"> /isg;

$ThePost =~ s/(\[QUOTE\])(.+?)(\[\/QUOTE\])/ <BLOCKQUOTE><font size="1" face="$FontFace">quote:<\/font><HR>$2<HR><\/BLOCKQUOTE>/isg;

$ThePost =~ s/(\[i\])(.+?)(\[\/i\])/<i>$2<\/i>/isg;

$ThePost =~ s/(\[b\])(.+?)(\[\/b\])/<b>$2<\/b>/isg;

return ($ThePost);

}

sub EditUBBConvert {
my $EditThis = shift;
$EditThis =~ s/(<A HREF="http:\/\/)(\S+)(" TARGET=_blank>)(\S+)(<\/A>)/\[URL\]$2\[\/URL\]/isg;
$EditThis =~ s/(<A HREF="mailto:)(\S+)(">)(\S+)(<\/A>)/\[EMAIL\]$2\[\/EMAIL\]/isg;
$EditThis =~ s/(<BLOCKQUOTE><font size="1" face=".+?">quote:<\/font><HR>)(.+?)(<HR><\/BLOCKQUOTE>)/\[QUOTE\]$2\[\/QUOTE\]/isg;
$EditThis =~ s/(<i>)(.+?)(<\/i>)/\[i\]$2\[\/i\]/isg;

$EditThis =~ s/(<b>)(.+?)(<\/b>)/\[b\]$2\[\/b\]/isg;

if ($UBBImages ne "OFF") {
$EditThis =~ s/(<IMG SRC=")(\S+)(">)/\[IMG\]$2\[\/IMG\]/isg;
}
return ($EditThis);
}  #end EditUBBConvert


sub CensorCheck {
my $WordCheck = shift;
if ($Censor eq "ON") {
	for (@censored) {
		if (m/({)(.*)(})/) {
			$ThisWord = ("$2");
			$wordlength = length($ThisWord);
			$wordlength = $wordlength;
			$replaceword = "*" x $wordlength;
			$replaceword = "$replaceword ";
			$WordCheck =~ s/\b$ThisWord\b/$replaceword/isg;
		}  else {
		$wordlength = length($_);
		$replaceword = "*" x $wordlength;
		$WordCheck =~ s/$_/$replaceword/isg;
		}
	}
}
return($WordCheck);
}  # end CensorCheck

sub Smilies {
my $Graemlin = shift;
$Graemlin =~ s/\:\)/ <IMG SRC="$NonCGIURL\/smile.gif">/isg;
$Graemlin =~ s/\:\(/ <IMG SRC="$NonCGIURL\/frown.gif">/isg;
$Graemlin =~ s/\:D/ <IMG SRC="$NonCGIURL\/biggrin.gif">/isg;
$Graemlin =~ s/\&lt\;\)/\&lt\; \)/isg;
$Graemlin =~ s/\&gt\;\)/\&gt\; \)/isg;
$Graemlin =~ s/\;\)/ <IMG SRC="$NonCGIURL\/wink.gif">/isg;
$Graemlin =~ s/\:o/ <IMG SRC="$NonCGIURL\/redface.gif">/isg;
return ($Graemlin);
}

sub ConvertReturns {
my $ConvertReturns = shift;
$ConvertReturns =~ s/\n\r\n/<p>/g;
$ConvertReturns =~ s/\n/<br>/g;
$ConvertReturns =~ s/\r//g;
return ($ConvertReturns);
}

sub EliminateReturns {
my $ConvertReturns = shift;
$ConvertReturns =~ s/\n\r\n//g;
$ConvertReturns =~ s/\n//g;
$ConvertReturns =~ s/\r//g;
return ($ConvertReturns);
}


sub decodeURL  {
$_ = shift;
tr/+/ /;
s/%(..)/pack('c', hex($1))/eg;
return($_);
}

# READ PARSE DIE IS TAKEN FROM cgi-lib.pl by Steven E. Brenner
# S.E.Brenner@bioc.cam.ac.uk
# $Id: cgi-lib.pl,v 2.12 1996/06/19 13:46:01 brenner Exp $
#
# Copyright (c) 1996 Steven E. Brenner
sub ReadParse {

$cgi_lib'version = sprintf("%d.%02d", q$Revision: 2.12 $ =~ /(\d+)\.(\d+)/);


# Parameters affecting cgi-lib behavior
# User-configurable parameters affecting file upload.
$cgi_lib'maxdata    = 131072;    # maximum bytes to accept via POST - 2^17
$cgi_lib'writefiles =      0;    # directory to which to write files, or
                                 # 0 if files should not be written
$cgi_lib'filepre    = "cgi-lib"; # Prefix of file names, in directory above

# Do not change the following parameters unless you have special reasons
$cgi_lib'bufsize  =  8192;    # default buffer size when reading multipart
$cgi_lib'maxbound =   100;    # maximum boundary length to be encounterd
$cgi_lib'headerout =    0;    # indicates whether the header has been printed
  local (*in) = shift if @_;    # CGI input
  local (*incfn,                # Client's filename (may not be provided)
	 *inct,                 # Client's content-type (may not be provided)
	 *insfn) = @_;          # Server's filename (for spooled files)
  local ($len, $type, $meth, $errflag, $cmdflag, $perlwarn, $got);
	
  $perlwarn = $^W;
  $^W = 0;

  binmode(STDIN);   # we need these for DOS-based systems
  binmode(STDOUT);  # and they shouldn't hurt anything else 
  binmode(STDERR);
	
  # Get several useful env variables
  $type = $ENV{'CONTENT_TYPE'};
  $len  = $ENV{'CONTENT_LENGTH'};
  $meth = $ENV{'REQUEST_METHOD'};
  
  if ($len > $cgi_lib'maxdata) { #'
      &CgiDie("cgi-lib.pl: Request to receive too much data: $len bytes\n");
  }
  
  if (!defined $meth || $meth eq '' || $meth eq 'GET' || 
      $type eq 'application/x-www-form-urlencoded') {
    local ($key, $val, $i);
	
    # Read in text
    if (!defined $meth || $meth eq '') {
      $in = $ENV{'QUERY_STRING'};
      $cmdflag = 1;  # also use command-line options
    } elsif($meth eq 'GET' || $meth eq 'HEAD') {
      $in = $ENV{'QUERY_STRING'};
    } elsif ($meth eq 'POST') {
        if (($got = read(STDIN, $in, $len) != $len))
	  {$errflag="Short Read: wanted $len, got $got\n"};
    } else {
      &CgiDie("cgi-lib.pl: Unknown request method: $meth\n");
    }

    @in = split(/[&;]/,$in); 
    push(@in, @ARGV) if $cmdflag; # add command-line parameters

    foreach $i (0 .. $#in) {
      # Convert plus to space
      $in[$i] =~ s/\+/ /g;

      # Split into key and value.  
      ($key, $val) = split(/=/,$in[$i],2); # splits on the first =.

      # Convert %XX from hex numbers to alphanumeric
      $key =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;
      $val =~ s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;

      # Associate key and value
      $in{$key} .= "\0" if (defined($in{$key})); # \0 is the multiple separator
      $in{$key} .= $val;
    }

  } elsif ($ENV{'CONTENT_TYPE'} =~ m#^multipart/form-data#) {
    # for efficiency, compile multipart code only if needed
$errflag = !(eval <<'END_MULTIPART');

    local ($buf, $boundary, $head, @heads, $cd, $ct, $fname, $ctype, $blen);
    local ($bpos, $lpos, $left, $amt, $fn, $ser);
    local ($bufsize, $maxbound, $writefiles) = 
      ($cgi_lib'bufsize, $cgi_lib'maxbound, $cgi_lib'writefiles);


    # The following lines exist solely to eliminate spurious warning messages
    $buf = ''; 

    ($boundary) = $type =~ /boundary="([^"]+)"/; #";   # find boundary
    ($boundary) = $type =~ /boundary=(\S+)/ unless $boundary;
    &CgiDie ("Boundary not provided: probably a bug in your server") 
      unless $boundary;
    $boundary =  "--" . $boundary;
    $blen = length ($boundary);

    if ($ENV{'REQUEST_METHOD'} ne 'POST') {
      &CgiDie("Invalid request method for  multipart/form-data: $meth\n");
    }

    if ($writefiles) {
      local($me);
      stat ($writefiles);
      $writefiles = "/tmp" unless  -d _ && -r _ && -w _;
      # ($me) = $0 =~ m#([^/]*)$#;
      $writefiles .= "/$cgi_lib'filepre"; 
    }

    $left = $len;
   PART: # find each part of the multi-part while reading data
    while (1) {
      die $@ if $errflag;

      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ?  $bufsize+$maxbound-length($buf): $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;

      $in{$name} .= "\0" if defined $in{$name}; 
      $in{$name} .= $fn if $fn;

      $name=~/([-\w]+)/;  # This allows $insfn{$name} to be untainted
      if (defined $1) {
        $insfn{$1} .= "\0" if defined $insfn{$1}; 
        $insfn{$1} .= $fn if $fn;
      }
 
     BODY: 
      while (($bpos = index($buf, $boundary)) == -1) {
        die $@ if $errflag;
        if ($name) {  # if no $name, then it's the prologue -- discard
          if ($fn) { print FILE substr($buf, 0, $bufsize); }
          else     { $in{$name} .= substr($buf, 0, $bufsize); }
        }
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, $maxbound)) != $amt);  
	die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      if (defined $name) {  # if no $name, then it's the prologue -- discard
        if ($fn) { print FILE substr($buf, 0, $bpos-2); }
        else     { $in {$name} .= substr($buf, 0, $bpos-2); } # kill last \r\n
      }
      close (FILE);
      last PART if substr($buf, $bpos + $blen, 4) eq "--\r\n";
      substr($buf, 0, $bpos+$blen+2) = '';
      $amt = ($left > $bufsize+$maxbound-length($buf) 
	      ? $bufsize+$maxbound-length($buf) : $left);
      $errflag = (($got = read(STDIN, $buf, $amt, length($buf))) != $amt);
      die "Short Read: wanted $amt, got $got\n" if $errflag;
      $left -= $amt;


      undef $head;  undef $fn;
     HEAD:
      while (($lpos = index($buf, "\r\n\r\n")) == -1) { 
        die $@ if $errflag;
        $head .= substr($buf, 0, $bufsize);
        $buf = substr($buf, $bufsize);
        $amt = ($left > $bufsize ? $bufsize : $left); #$maxbound==length($buf);
        $errflag = (($got = read(STDIN, $buf, $amt, $maxbound)) != $amt);  
        die "Short Read: wanted $amt, got $got\n" if $errflag;
        $left -= $amt;
      }
      $head .= substr($buf, 0, $lpos+2);
      push (@in, $head);
      @heads = split("\r\n", $head);
      ($cd) = grep (/^\s*Content-Disposition:/i, @heads);
      ($ct) = grep (/^\s*Content-Type:/i, @heads);

      ($name) = $cd =~ /\bname="([^"]+)"/i; #"; 
      ($name) = $cd =~ /\bname=([^\s:;]+)/i unless defined $name;  

      ($fname) = $cd =~ /\bfilename="([^"]*)"/i; #"; # filename can be null-str
      ($fname) = $cd =~ /\bfilename=([^\s:;]+)/i unless defined $fname;
      $incfn{$name} .= (defined $in{$name} ? "\0" : "") . $fname;

      ($ctype) = $ct =~ /^\s*Content-type:\s*"([^"]+)"/i;  #";
      ($ctype) = $ct =~ /^\s*Content-Type:\s*([^\s:;]+)/i unless defined $ctype;
      $inct{$name} .= (defined $in{$name} ? "\0" : "") . $ctype;

      if ($writefiles && defined $fname) {
        $ser++;
	$fn = $writefiles . ".$$.$ser";
	open (FILE, ">$fn") || &CgiDie("Couldn't open $fn\n");
        binmode (FILE);  # write files accurately
      }
      substr($buf, 0, $lpos+4) = '';
      undef $fname;
      undef $ctype;
    }

1;
END_MULTIPART
    if ($errflag) {
      local ($errmsg, $value);
      $errmsg = $@ || $errflag;
      foreach $value (values %insfn) {
        unlink(split("\0",$value));
      }
      &CgiDie($errmsg);
    } else {
      # everything's ok.
    }
  } else {
    &CgiDie("cgi-lib.pl: Unknown Content-type: $ENV{'CONTENT_TYPE'}\n");
  }

  # no-ops to avoid warnings
  $insfn = $insfn;
  $incfn = $incfn;
  $inct  = $inct;

  $^W = $perlwarn;

  return ($errflag ? undef :  scalar(@in)); 
}

#  CGI DIE IS TAKEN FROM cgi-lib.pl by Steven E. Brenner
# S.E.Brenner@bioc.cam.ac.uk
# $Id: cgi-lib.pl,v 2.12 1996/06/19 13:46:01 brenner Exp $
#
# Copyright (c) 1996 Steven E. Brenner

sub CgiDie {
  local (@msg) = @_;
  &CgiError (@msg);
  die @msg;
}


sub StandardHTML {
my $TextToPrint = shift;

print<<TheHTML;
<HTML>
<HEAD>
<TITLE>$GBTitle</TITLE>
</HEAD>
<BODY $BGColor text="$TextColor" link="$LinkColor" vlink="$VisitedLinkColor">
<CENTER><A HREF="ugb.cgi"><IMG SRC="$NonCGIURL/ugb.jpg" BORDER=0></a></CENTER>
<P><BR><blockquote>
<B><FONT FACE="$FontFace" size="$TextSize">$TextToPrint
</FONT></B></blockquote>
<center>
<BR><BR>
<FONT SIZE="1" FACE="$FontFace"><A HREF="http://www.madronapark.com/ugb">Ultimate Guestbook</A><BR>&copy; <A HREF="http://www.madronapark.com">Madrona Park, Inc.</A>, 1999.</FONT>
</center>
</BODY></HTML>
TheHTML
}
sub OpenFile {
my $FilePath = shift;
open (THISONE, "$FilePath") or die("Unable to open $FilePath.");
my @thisarray = <THISONE>;
close (THISONE);
return(@thisarray);
}

1;
